<?
sapp_include_once('common.php');

function better_srand($seed = '') {
    static $wascalled = FALSE;
    if (!$wascalled) {
        if ($seed === '') {
            list($usec, $sec) = explode(" ", microtime());
            if ($usec > 0.1)
                $seed = (double) $usec * $sec;
            else // once in a while use the combined LCG entropy
                $seed = (double) 1000000 * substr(uniqid("", true), 13);
        }
        if (function_exists('mt_srand')) {
            mt_srand($seed); // mersenne twister
        } else {
            srand($seed);
        }
        $wascalled = TRUE;
    }
}

function rand_ascii($length = 1) {
    better_srand();
    $s = "";
    for ($i = 1; $i <= $length; $i++) {
        // return only typeable 7 bit ascii, avoid quotes
        if (function_exists('mt_rand'))
            // the usually bad glibc srand()
            $s .= chr(mt_rand(40, 126));
        else
            $s .= chr(rand(40, 126));
    }
    return $s;
}

function create_wiki_admin_pass($pass){
            if (function_exists('crypt')) {
                $salt_length = max(CRYPT_SALT_LENGTH,
                                    2 * CRYPT_STD_DES,
                                    9 * CRYPT_EXT_DES,
                                   12 * CRYPT_MD5,
                                   16 * CRYPT_BLOWFISH);
                // generate an encrypted password
                $crypt_pass = crypt($pass, rand_ascii($salt_length));
                return $crypt_pass;
            } else {
                return $pass;
            }

}

function form_handler()
{
	$valid = true;

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	$locale = sapp_get_submit_value('locale');
	sapp_set_param('locale', $locale);
	
//	$sampler = sapp_get_submit_value('sampler');
//	sapp_set_param('sampler', $sampler);
	
	//check db name
	$dbname = sapp_get_submit_value('dbname');
	if (!check_dbName($dbname)) {
		sapp_set_wrong('dbname', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('dbname', $dbname);

	if (sapp_is_database_exists($dbname, 'mysql')) {
		sapp_set_wrong('dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$dbuser = sapp_get_submit_value('dbuser');
	if (!check_dbUserName($dbuser)) {
		sapp_set_wrong('dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('dbuser', $dbuser);

	//check db passwd
	$dbpasswd = sapp_get_submit_value('dbpasswd');
	$dbconfirm = sapp_get_submit_value('dbconfirm');
	if ('' == $dbpasswd) {
		if (!sapp_get_param('dbpasswd')) {
			sapp_set_wrong('dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$dbpasswd = sapp_get_param('dbpasswd');
		}
	} elseif ($dbpasswd != $dbconfirm) {
		sapp_set_wrong('dbpasswd', msg('password__not_match'));
		sapp_set_wrong('dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('dbpasswd', $dbpasswd);
	}
	
	if (sapp_is_database_user_exists($dbname, 'mysql', $dbuser, $dbpasswd)) {
		sapp_set_wrong('dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}

	//check db user
	$admin_name = sapp_get_submit_value('admin_name');
	if (!check_dbUserName($admin_name)) {
		sapp_set_wrong('admin_name', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('admin_name', $admin_name);

	//check admin password
	$admin_passwd = sapp_get_submit_value('admin_passwd');
	$admin_confirm = sapp_get_submit_value('admin_confirm');
	if ('' == $admin_passwd) {
		if (!sapp_get_param('admin_passwd')) {
			sapp_set_wrong('admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$admin_passwd = sapp_get_param('admin_passwd');
		}
	} elseif ($admin_passwd != $admin_confirm) {
		sapp_set_wrong('admin_passwd', msg('password__not_match'));
		sapp_set_wrong('admin_confirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('admin_passwd', create_wiki_admin_pass($admin_passwd));
	}
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($dbname, 'mysql')) {
		sapp_set_wrong('dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($dbname, 'mysql', $dbuser, $dbpasswd)) {
		sapp_set_wrong('dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}
?>
