<?
sapp_include_once('common.php');
function better_srand($seed = '') {
    static $wascalled = FALSE;
    if (!$wascalled) {
        if ($seed === '') {
            list($usec, $sec) = explode(" ", microtime());
            if ($usec > 0.1)
                $seed = (double) $usec * $sec;
            else // once in a while use the combined LCG entropy
                $seed = (double) 1000000 * substr(uniqid("", true), 13);
        }
        if (function_exists('mt_srand')) {
            mt_srand($seed); // mersenne twister
        } else {
            srand($seed);
        }
        $wascalled = TRUE;
    }
}
function rand_ascii($length = 1) {
    better_srand();
    $s = "";
    for ($i = 1; $i <= $length; $i++) {
        // return only typeable 7 bit ascii, avoid quotes
        if (function_exists('mt_rand'))
            // the usually bad glibc srand()
            $s .= chr(mt_rand(40, 126));
        else
            $s .= chr(rand(40, 126));
    }
    return $s;
}

function create_wiki_admin_pass($pass){
            if (function_exists('crypt')) {
                $salt_length = max(CRYPT_SALT_LENGTH,
                                    2 * CRYPT_STD_DES,
                                    9 * CRYPT_EXT_DES,
                                   12 * CRYPT_MD5,
                                   16 * CRYPT_BLOWFISH);
                // generate an encrypted password
                $crypt_pass = crypt($pass, rand_ascii($salt_length));
                return $crypt_pass;
            } else {
                return $pass;
            }

}

function form_handler()
{
	$valid = true;

	$admin_name = sapp_get_submit_value('admin_name');
	if (!check_sys_login($admin_name)) {
		sapp_set_wrong('admin_name', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('admin_name', $admin_name);

	$locale = sapp_get_submit_value('locale');
	sapp_set_param('locale', $locale);

	//check admin password
	$admin_passwd = sapp_get_submit_value('admin_passwd');
	$admin_confirm = sapp_get_submit_value('admin_confirm');
	if ('' == $admin_passwd) {
		if (!sapp_get_param('admin_passwd')) {
			sapp_set_wrong('admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$admin_passwd = sapp_get_param('admin_passwd');
		}
	} elseif ($admin_passwd != $admin_confirm) {
		sapp_set_wrong('admin_passwd', msg('password__not_match'));
		sapp_set_wrong('admin_confirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('admin_passwd', create_wiki_admin_pass($admin_passwd));
	}
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}

	return 2;
}
?>
